/* fftView.cpp : implementation of the CFftView class
   ***************************************************************************
   implmentation de la FFT dans le but de filtrer des images 
   l'image  filtrer doit tre au format binaire .raw
   sa taille peut tre chang dans les variables globales dfinies si-dessous 
   son chemin d'accs peut tre chang dans les variables globales dfinies si-dessous
   il sauve le spectre et l'image reconstitue et traite
   ***************************************************************************
  */

#include "stdio.h"
#include "stdlib.h"


#include "FastFour.h"

#include "stdafx.h"
#include "fft.h"

#include "fftDoc.h"
#include "fftView.h"
#include "math.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Initialisation des variables pour le type de filtre
// a appliquer, et pour les cutoffs correspondants.

// filter peut prendre 3 valeurs:
// 0 -> pas de filtre
// 1 -> filtre passe bas pour les valeurs inferieures  coupure1
// 2 -> filtre passe bande pour les valeurs comprises entre coupure1 et coupure2
// 3 -> filtre passe haut pour les valeurs suprieures  coupure1

int filter = 0;  // type de filtre

double coupure1 = 50,coupure2=150;

// hauteur et largeur de l'image  traiter
int hauteur=256;
int largeur=256;

// chemin de l'image  traiter
char chemin[12] = "d:\\test.raw";
// chemin du spectre  sauvegarder
char cheminSpectre[15] = "d:\\spectre.raw";
// chemin de l'image traite  sauvegarder
char cheminReconstitution[22] = "d:\\reconstitution.raw";


//***************************************************************************
double **grid; // grille contenant l'image a traiter
double **gridImaginaire;
int i,j;

int reverse=1;
int sensDeLaTransfo=1;


FILE *fptr;

int borne1=hauteur/2;
int borne2=hauteur-1;
int **image;
int **image2;
int **image3;
int **imaginaire;

double mean = 0;
double r,r1,r2,r3,r4;

/////////////////////////////////////////////////////////////////////////////
// CFftView

IMPLEMENT_DYNCREATE(CFftView, CView)

BEGIN_MESSAGE_MAP(CFftView, CView)
	//{{AFX_MSG_MAP(CFftView)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFftView construction/destruction

CFftView::CFftView()
{
	CFile myFile;
	CFileException fileException;

	// Declaration des tableaux et allocation de la mmoire.
	
	// les tableaux de double servent pour les calculs.
	// les tableaux de int servent pour l'affichage des images.

	if ((grid = (double **)malloc(hauteur * sizeof(double))) == NULL) 
	{
      fprintf(stderr,"Impossible d'allouer la mmoire pour crer la grille\n");
      exit(0);
	}
	
	for (i=0;i<hauteur;i++)
	{
		grid[i] = (double *)malloc(hauteur * sizeof(double));
	}

	if ((gridImaginaire = (double **)malloc(hauteur * sizeof(double))) == NULL) 
	{
      fprintf(stderr,"Impossible d'allouer la mmoire pour crer la grille d'imaginaire\n");
      exit(0);
	}
	
	for (i=0;i<hauteur;i++)
	{
		gridImaginaire[i] = (double *)malloc(hauteur * sizeof(double));
	}
	
	image = (int **)malloc(largeur * sizeof(int));
	for (i=0;i<largeur;i++)
		image[i] = (int *)malloc(largeur * sizeof(int));

	imaginaire = (int **)malloc(largeur * sizeof(int));
	for (i=0;i<largeur;i++)
		imaginaire[i] = (int *)malloc(largeur * sizeof(int));

	image2 = (int **)malloc(largeur * sizeof(int));
	for (i=0;i<largeur;i++)
		image2[i] = (int *)malloc(largeur * sizeof(int));

	image3 = (int **)malloc(largeur * sizeof(int));
	for (i=0;i<largeur;i++)
		image3[i] = (int *)malloc(largeur * sizeof(int));

	// *******************************
	// Lecture de l'image source.
	// *******************************

	char* pszFileName41 = chemin;


	if ( !myFile.Open( pszFileName41, CFile::modeRead, &fileException) )
	{
		TRACE( "Can't open file %s, error = %u\n",
        pszFileName41, fileException.m_cause );
	}

	for (i=0;i<hauteur;i++) 
	{
		for (j=0;j<hauteur;j++)
		{
			
			myFile.Read( &image[i][j],1);  
		}
	}
	
	myFile.Close();

	// Transfert des tableaux.
			
	for (i=0;i<hauteur;i++) 
	{
		for (j=0;j<hauteur;j++)
		{
			gridImaginaire[i][j] = 0; 
		}
	}


	for (i=0;i<largeur;i++)
		for (j=0;j<largeur;j++)
			grid[i][j]=image[i][j];

	for (i=0;i<largeur;i++)
		for (j=0;j<largeur;j++)
			imaginaire[i][j] = (int)gridImaginaire[i][j];

	
	// On soustrait la couleur moyenne de l'image a tous les pixels.

	for (j=0;j<largeur;j++) {
		for (i=0;i<largeur;i++) 
		{
			mean += image[i][j];
		}
	}

	mean /= (largeur * largeur);
	for (j=0;j<largeur;j++) 
		for (i=0;i<largeur;i++) 
			image[i][j]-= (int)mean;

	for (j=0;j<largeur;j++) 
		for (i=0;i<largeur;i++) 
			image2[i][j]=image[i][j];

	// Calcul de la FFT

	FFT2D(image, imaginaire, largeur, 1);


	// Transfert de tableau.

	for (i=0;i<largeur;i++)
	for (j=0;j<largeur;j++)
		image2[i][j] = image[i][j];

	// Modification de l'image en vue de l'afficher.

	FormImage(largeur, image2, image, imaginaire);

	
	if (reverse == 1)
	{
		for (i=0;i<borne1;i++)   // coin haut gauche
			for (j=0;j<borne1;j++)
			{
				image3[i][j]=image2[borne1-i][borne1-j];
			}
		for (i=0;i<borne1;i++)
			for (j=borne1;j<borne2;j++)
			{
				image3[i][j]=image2[borne1-i][borne2+borne1-j];
			}
		for (i=borne1;i<borne2;i++)
			for (j=0;j<borne1;j++)
			{
				image3[i][j]=image2[borne2+borne1-i][borne1-j];
			}
		for (i=borne1;i<borne2;i++)
			for (j=borne1;j<borne2;j++)
			{
				image3[i][j]=image2[borne2+borne1-i][borne2+borne1-j];
			}
	}

	// Sauvegarde de l'image du spectre de Fourier

	char* pszFileName = cheminSpectre;


	if ( !myFile.Open( pszFileName, CFile::modeCreate |   
          CFile::modeReadWrite ), &fileException )
	{
		TRACE( "Can't open file %s, error = %u\n",
        pszFileName, fileException.m_cause );
	}

	for (i=0;i<hauteur;i++) 
	{
		for (j=0;j<hauteur;j++)
		{
			
			myFile.Write( &image3[i][j], sizeof( char ));  
		}
	}

	myFile.Close();


	// Application des filtres.

	for (i=0;i<hauteur;i++) 
	{
      for (j=0;j<hauteur;j++) 
	  {
         r1 = i*i + j*j;
         r2 = (i-hauteur)*(i-hauteur) + j*j;
         r3 = i*i + (j-hauteur)*(j-hauteur);
         r4 = (i-hauteur)*(i-hauteur) + (j-hauteur)*(j-hauteur);
         r = min(r1,r2);
         r = min(r,r3);
         r = min(r,r4);

			switch (filter) 
			{
			case 0:		// Pas de filtrage.
				break;
			case 1:		// Passe-Bas.
            if (r > coupure1*coupure1) {
               image[i][j] = 0;
               imaginaire[i][j] = 0;
            }
				break;
			case 2:		// Passe-Bande.
            if (r < coupure1*coupure1 || r > coupure2*coupure2) {
               image[i][j] = 0;
               imaginaire[i][j] = 0;
            }
				break;
   		case 3:           // Passe-Haut.
            if (r < coupure1*coupure1) 
			{
               image[i][j] = 0;
               imaginaire[i][j] = 0;
            }
				break;
		default:
				fprintf(stderr,"No such filter defined\n");
				exit(-1);
				break;
			}

		} 
	} 

	// Calcul de la FFT inverse.

	FFT2D(image, imaginaire, largeur, -1);

	// Modification de l'image en vue de l'afficher.

	FormImage(largeur, image2, image, imaginaire);
	


	// Sauvegarde de l'image finale.

	char* pszFileName3 = cheminReconstitution;
	
	if ( !myFile.Open( pszFileName3, CFile::modeCreate |   
          CFile::modeReadWrite ), &fileException )
	{
		TRACE( "Can't open file %s, error = %u\n",
        pszFileName3, fileException.m_cause );
	}

	for (i=0;i<hauteur;i++) 
	{
		for (j=0;j<hauteur;j++)
		{
			
			myFile.Write( &image2[i][j], sizeof( char ) );  
		}
	}
	myFile.Close();

	

	//free(grid);
	//free(gridImaginaire);
	//free(image);
	//free(imaginaire);


}



CFftView::~CFftView()
{
	// Libere la mmoire.

	free(grid);
	free(gridImaginaire);
	free(image);
	free(image2);
	free(image3);
	free(imaginaire);
}

int CFftView::expoDeDeux(int largeur)
{
	int  i=1;
	int puissance=0;
	while( i != largeur )
	{
		i=i*2;
		puissance++;
	}
	return (puissance);
}

// la FFT de la mort




///restructuration de l'image
/////////////////////////////

int CFftView::FormImage(int largeur,int **image2, int **image, int **imaginaire) 
{
	int i,j;
	double scale=0,mag,rmin=1e32,rmax=-1e32,temp;
	double couleur;

	// Determine la maximum des modules.

	for (i=0;i<largeur;i++) 
	{
		for (j=0;j<largeur;j++) 
		{
			temp = (image[i][j]*image[i][j]+imaginaire[i][j]*imaginaire[i][j]);
			mag = sqrt(temp);
			scale = max(mag,scale);
			rmin = min(rmin,image[i][j]);
			rmax = max(rmax,image[i][j]);
			
		}
	}

	// Reforme l'image en niveaux de gris.

      for (i=0;i<largeur;i++) 
	  {
		 for (j=0;j<largeur;j++) 
		 {
			mag = sqrt(image[i][j]*image[i][j]+imaginaire[i][j]*imaginaire[i][j]);
			couleur = 255 * mag / scale;
			image2[i][j] = (int)couleur;
		
		 }
	  }

	return(1);
}



int CFftView::FFT(int dir,int m,double *x,double *y)
{
   long nn,i,i1,j,k,i2,l,l1,l2;
   double c1,c2,tx,ty,t1,t2,u1,u2,z;

   // Calcul du nombre de points.

   nn = 1;
   for (i=0;i<m;i++)
      nn *= 2;

   // Inversion des bits.
   
   i2 = nn >> 1;
   j = 0;
   for (i=0;i<nn-1;i++) {
      if (i < j) {
         tx = x[i];
         ty = y[i];
         x[i] = x[j];
         y[i] = y[j];
         x[j] = tx;
         y[j] = ty;
      }
      k = i2;
      while (k <= j) {
         j -= k;
         k >>= 1;
      }
      j += k;
   }

   // Calcul de la FFT.

   c1 = -1.0;
   c2 = 0.0;
   l2 = 1;
   for (l=0;l<m;l++) {
      l1 = l2;
      l2 <<= 1;
      u1 = 1.0;
      u2 = 0.0;
      for (j=0;j<l1;j++) {
         for (i=j;i<nn;i+=l2) {
            i1 = i + l1;
            t1 = u1 * x[i1] - u2 * y[i1];
            t2 = u1 * y[i1] + u2 * x[i1];
            x[i1] = x[i] - t1;
            y[i1] = y[i] - t2;
            x[i] += t1;
            y[i] += t2;
         }
         z =  u1 * c1 - u2 * c2;
         u2 = u1 * c2 + u2 * c1;
         u1 = z;
      }
      c2 = sqrt((1.0 - c1) / 2.0);
      if (dir == 1)
         c2 = -c2;
      c1 = sqrt((1.0 + c1) / 2.0);
   }

   //Mise a l'echelle.

   if (dir == -1) {
      for (i=0;i<nn;i++) {
         x[i] /= (double)nn;
         y[i] /= (double)nn;
      }
   }

   return(1);
}

void CFftView::CutOff(double **image, int largeur)
{
	int i,j;

	for (i=0;i<largeur;i++)
		for (j=0;j<largeur;j++)
		{
			if (image[i][j]>100) 
				image[i][j]=0;
		}
}

int CFftView::FFT2D(int **image, int **imaginaire,int largeur,int dir)
{
   int i,j;
   int m;
   double *real,*imag;

   m = expoDeDeux(largeur);

   printf("m : %d\n",m);



   // FFT sur les lignes.

   real = (double *)malloc(largeur * sizeof(double));
   imag = (double *)malloc(largeur  * sizeof(double));
   if (real == NULL || imag == NULL)
      return(-1);
    

   for (j=0;j<largeur;j++) {
      for (i=0;i<largeur;i++) {
         real[i] = image[i][j];
         imag[i] = imaginaire[i][j];
      }
      FFT(dir,m,real,imag);
      for (i=0;i<largeur;i++) {
         image[i][j] = (int)real[i];
         imaginaire[i][j] = (int)imag[i];
      }
   }
   free(real);
   free(imag);

   //FFT sur les colonnes.

   real = (double *)malloc(largeur * sizeof(double));
   imag = (double *)malloc(largeur * sizeof(double));
   if (real == NULL || imag == NULL)
      return(-1);
   

   for (i=0;i<largeur;i++) {
      for (j=0;j<largeur;j++) {
         real[j] = image[i][j];
         imag[j] = imaginaire[i][j];
      }
      FFT(dir,m,real,imag);
      for (j=0;j<largeur;j++) {
         image[i][j] = (int)real[j];
         imaginaire[i][j] = (int)imag[j];
      }
   }
   free(real);
   free(imag);

   return(1);
}


BOOL CFftView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CFftView drawing

void CFftView::OnDraw(CDC* pDC)
{
//	int temp;
	int borne1=hauteur/2;
	int borne2=hauteur-1;

	CFftDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// Affichage de l'image finale  l'ecran.

	for (j=0;j<hauteur;j++) 
	{
		for (i=0;i<hauteur;i++)
		{
			pDC->SetPixel(j,i,PALETTERGB(image2[i][j],image2[i][j],image2[i][j]));
		}
	}

}

/////////////////////////////////////////////////////////////////////////////
// CFftView printing

BOOL CFftView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CFftView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CFftView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CFftView diagnostics

#ifdef _DEBUG
void CFftView::AssertValid() const
{
	CView::AssertValid();
}

void CFftView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CFftDoc* CFftView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CFftDoc)));
	return (CFftDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CFftView message handlers
